<template>
  <header
    class="ui-desktop-header"
    :class="{ '-mobile': !isDesktop }"
  >
    <div class="ui-desktop-header-bg" />
    <div class="uikit-flex uikit-items-center uikit-relative z-10 uikit-w-full uikit-h-full">
      <ui-header-logo
        :is-mobile="!isDesktop"
        :logo-link="logoLink"
      />

      <ul class="ml-18 flex-1 uikit-flex uikit-space-x-32 uikit-h-full">
        <li
          class="uikit-h-full"
          :key="index"
          v-for="(link, index) in links"
        >
          <ui-link
            class="ui-link uikit-text-14 uikit-flex uikit-flex-col uikit-justify-center uikit-items-center uikit-leading-none uikit-h-full"
            v-bind="link"
          />
        </li>
        <li class="uikit-h-full uikit-flexflex-1 justify-end">
          <ui-link
            class="uikit-text-14 uikit-flex uikit-flex-col uikit-justify-center uikit-items-center uikit-leading-none uikit-h-full"
            href="https://docs.slr.finance"
            rel="noopener noreferrer"
            target="_blank"
          >
            Knowledge base
          </ui-link>
        </li>
      </ul>

      <div class="ml-16">
        <slot name="action" />
      </div>
    </div>
  </header>
</template>

<script lang="ts">
  import type { RouteLocationRaw } from 'vue-router'
  import type { UiLinkProps } from '../UiLink'
  import { defineComponent, onUnmounted, PropType } from 'vue'
  import { useStyleTag, useBreakpoints, useEventListener } from '@vueuse/core'
  import { UiLink } from '../UiLink'
  import UiHeaderLogo from './UiHeaderLogo.vue'
  import { getWindow } from '../../utils/getElement'

  const getScrollFactorStyle = (scrollY: number) => {
    const scrollFactor = Math.min(scrollY, 97) / 97

    return `:root { --app-ui-header-scroll-factor: ${scrollFactor}; }`
  }

  export default defineComponent({
    name: 'ui-desktop-header',
    props: {
      logoLink: {
        type: [String, Object] as PropType<RouteLocationRaw>,
      },
      links: {
        type: Array as PropType<UiLinkProps[]>,
      },
    },
    setup() {
      // Handle scroll [BEGIN]
      let ticking = false
      const window = getWindow()

      const handleScroll = () => {
        if (ticking || !window) {
          return
        }

        const currentPos = window.scrollY
        ticking = true

        window.requestAnimationFrame(() => {
          css.value = getScrollFactorStyle(currentPos)
          ticking = false

          if (currentPos !== window.scrollY) {
            handleScroll()
          }
        })
      }

      let scrollY = 0

      if (window) {
        scrollY = window.scrollY
  
        useEventListener(window, 'scroll', (event) => {
          handleScroll()
        })
      }

      const { css } = useStyleTag(getScrollFactorStyle(scrollY))
      // Handle scroll [END]

      const { isDesktop, isLaptop } = useBreakpoints({ isDesktop: 980, isLaptop: 450 })

      onUnmounted(() => {
        css.value = getScrollFactorStyle(0)
      })

      return {
        isDesktop,
        isLaptop,
      }
    },
    components: {
      UiLink,
      UiHeaderLogo,
    },
  })
</script>

<style>
  .ui-desktop-header {
    transform: translateY(calc(var(--app-ui-header-scroll-factor) * var(--app-ui-header-scroll-padding) * -1));
    height: calc(var(--app-ui-header-base-height) + var(--app-ui-header-scroll-padding));
    padding-top: var(--app-ui-header-scroll-padding);

    @apply uikit-fixed uikit-z-header uikit-top-0 uikit-left-0 uikit-w-full uikit-px-ui-page-spacing uikit-pt-32 selection:uikit-bg-green-atomic selection:uikit-text-black;
  }

  .ui-desktop-header > .ui-desktop-header-bg {
    z-index: 0;
    opacity: var(--app-ui-header-scroll-factor);

    @apply uikit-backdrop-blur-8 uikit-absolute uikit-top-0 uikit-left-0 uikit-w-full uikit-h-full uikit-bg-black uikit-bg-opacity-30;
  }
</style>
